--- gcc/tree.h.jj	2017-04-18 15:13:25.180398014 +0200
+++ gcc/tree.h	2017-04-19 08:16:12.859844328 +0200
@@ -4068,7 +4068,7 @@ extern tree build_truth_vector_type (uns
 extern tree build_same_sized_truth_vector_type (tree vectype);
 extern tree build_opaque_vector_type (tree innertype, int nunits);
 extern tree build_index_type (tree);
-extern tree build_array_type (tree, tree);
+extern tree build_array_type (tree, tree, bool = false);
 extern tree build_nonshared_array_type (tree, tree);
 extern tree build_array_type_nelts (tree, unsigned HOST_WIDE_INT);
 extern tree build_function_type (tree, tree);
--- gcc/tree.c.jj	2017-04-18 15:13:25.158398308 +0200
+++ gcc/tree.c	2017-04-19 08:17:50.938542960 +0200
@@ -7073,7 +7073,9 @@ type_cache_hasher::equal (type_hash *a,
         break;
       return 0;
     case ARRAY_TYPE:
-      return TYPE_DOMAIN (a->type) == TYPE_DOMAIN (b->type);
+      return (TYPE_TYPELESS_STORAGE (a->type)
+	      == TYPE_TYPELESS_STORAGE (b->type)
+	      && TYPE_DOMAIN (a->type) == TYPE_DOMAIN (b->type));
 
     case RECORD_TYPE:
     case UNION_TYPE:
@@ -8350,10 +8352,12 @@ subrange_type_for_debug_p (const_tree ty
 
 /* Construct, lay out and return the type of arrays of elements with ELT_TYPE
    and number of elements specified by the range of values of INDEX_TYPE.
+   If TYPELESS_STORAGE is true, TYPE_TYPELESS_STORAGE flag is set on the type.
    If SHARED is true, reuse such a type that has already been constructed.  */
 
 static tree
-build_array_type_1 (tree elt_type, tree index_type, bool shared)
+build_array_type_1 (tree elt_type, tree index_type, bool typeless_storage,
+		    bool shared)
 {
   tree t;
 
@@ -8367,6 +8371,7 @@ build_array_type_1 (tree elt_type, tree
   TREE_TYPE (t) = elt_type;
   TYPE_DOMAIN (t) = index_type;
   TYPE_ADDR_SPACE (t) = TYPE_ADDR_SPACE (elt_type);
+  TYPE_TYPELESS_STORAGE (t) = typeless_storage;
   layout_type (t);
 
   /* If the element type is incomplete at this point we get marked for
@@ -8381,6 +8386,7 @@ build_array_type_1 (tree elt_type, tree
       hstate.add_object (TYPE_HASH (elt_type));
       if (index_type)
 	hstate.add_object (TYPE_HASH (index_type));
+      hstate.add_flag (typeless_storage);
       t = type_hash_canon (hstate.end (), t);
     }
 
@@ -8396,7 +8402,7 @@ build_array_type_1 (tree elt_type, tree
 	  = build_array_type_1 (TYPE_CANONICAL (elt_type),
 				index_type
 				? TYPE_CANONICAL (index_type) : NULL_TREE,
-				shared);
+				typeless_storage, shared);
     }
 
   return t;
@@ -8405,9 +8411,9 @@ build_array_type_1 (tree elt_type, tree
 /* Wrapper around build_array_type_1 with SHARED set to true.  */
 
 tree
-build_array_type (tree elt_type, tree index_type)
+build_array_type (tree elt_type, tree index_type, bool typeless_storage)
 {
-  return build_array_type_1 (elt_type, index_type, true);
+  return build_array_type_1 (elt_type, index_type, typeless_storage, true);
 }
 
 /* Wrapper around build_array_type_1 with SHARED set to false.  */
@@ -8415,7 +8421,7 @@ build_array_type (tree elt_type, tree in
 tree
 build_nonshared_array_type (tree elt_type, tree index_type)
 {
-  return build_array_type_1 (elt_type, index_type, false);
+  return build_array_type_1 (elt_type, index_type, false, false);
 }
 
 /* Return a representation of ELT_TYPE[NELTS], using indices of type
--- gcc/c-family/c-common.c.jj	2017-04-18 15:14:29.383541136 +0200
+++ gcc/c-family/c-common.c	2017-04-19 08:15:55.346076712 +0200
@@ -6386,7 +6386,6 @@ complete_array_type (tree *ptype, tree i
 {
   tree maxindex, type, main_type, elt, unqual_elt;
   int failure = 0, quals;
-  hashval_t hashcode = 0;
   bool overflow_p = false;
 
   maxindex = size_zero_node;
@@ -6480,13 +6479,15 @@ complete_array_type (tree *ptype, tree i
   TYPE_DOMAIN (main_type)
     = build_range_type (TREE_TYPE (maxindex),
 			build_int_cst (TREE_TYPE (maxindex), 0), maxindex);
+  TYPE_TYPELESS_STORAGE (main_type) = TYPE_TYPELESS_STORAGE (type);
   layout_type (main_type);
 
   /* Make sure we have the canonical MAIN_TYPE. */
-  hashcode = iterative_hash_object (TYPE_HASH (unqual_elt), hashcode);
-  hashcode = iterative_hash_object (TYPE_HASH (TYPE_DOMAIN (main_type)),
-				    hashcode);
-  main_type = type_hash_canon (hashcode, main_type);
+  inchash::hash hstate;
+  hstate.add_object (TYPE_HASH (unqual_elt));
+  hstate.add_object (TYPE_HASH (TYPE_DOMAIN (main_type)));
+  hstate.add_flag (TYPE_TYPELESS_STORAGE (main_type));
+  main_type = type_hash_canon (hstate.end (), main_type);
 
   /* Fix the canonical type.  */
   if (TYPE_STRUCTURAL_EQUALITY_P (TREE_TYPE (main_type))
@@ -6497,7 +6498,8 @@ complete_array_type (tree *ptype, tree i
 	       != TYPE_DOMAIN (main_type)))
     TYPE_CANONICAL (main_type)
       = build_array_type (TYPE_CANONICAL (TREE_TYPE (main_type)),
-			  TYPE_CANONICAL (TYPE_DOMAIN (main_type)));
+			  TYPE_CANONICAL (TYPE_DOMAIN (main_type)),
+			  TYPE_TYPELESS_STORAGE (main_type));
   else
     TYPE_CANONICAL (main_type) = main_type;
 
--- gcc/cp/tree.c.jj	2017-04-18 15:13:27.136371909 +0200
+++ gcc/cp/tree.c	2017-04-19 08:15:39.191291063 +0200
@@ -949,14 +949,14 @@ build_cplus_array_type (tree elt_type, t
     }
   else
     {
-      t = build_array_type (elt_type, index_type);
-      if (elt_type == unsigned_char_type_node
-	  || elt_type == signed_char_type_node
-	  || elt_type == char_type_node
-	  || (TREE_CODE (elt_type) == ENUMERAL_TYPE
-	      && TYPE_CONTEXT (elt_type) == std_node
-	      && !strcmp ("byte", TYPE_NAME_STRING (elt_type))))
-	TYPE_TYPELESS_STORAGE (t) = 1;
+      bool typeless_storage
+	= (elt_type == unsigned_char_type_node
+	   || elt_type == signed_char_type_node
+	   || elt_type == char_type_node
+	   || (TREE_CODE (elt_type) == ENUMERAL_TYPE
+	       && TYPE_CONTEXT (elt_type) == std_node
+	       && !strcmp ("byte", TYPE_NAME_STRING (elt_type))));
+      t = build_array_type (elt_type, index_type, typeless_storage);
     }
 
   /* Now check whether we already have this array variant.  */
--- gcc/testsuite/g++.dg/other/pr80423.C.jj	2017-04-19 08:14:42.539042760 +0200
+++ gcc/testsuite/g++.dg/other/pr80423.C	2017-04-19 08:14:42.539042760 +0200
@@ -0,0 +1,11 @@
+// PR middle-end/80423
+// { dg-do compile { target c++11 } }
+
+typedef unsigned char uint8_t;                                                                                                                     
+struct A {                                                                                                                                         
+  template <int N> A(unsigned char (&)[N]);                                                                                                        
+};                                                                                                                                                 
+void fn1(A) {                                                                                                                                      
+  uint8_t a[]{0};                                                                                                                                  
+  fn1(a);                                                                                                                                          
+}                                                                                                                                                  